> For the complete documentation index, see [llms.txt](https://docs.heisenware.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.heisenware.com/developers/vrpc/languages/arduino/examples/oled-display-agent.md).

# OLED Display Agent

```cpp
#include <SSD1311.h>
#include <WiFiNINA.h>
#include <vrpc.h>
#include "Wire.h"

const char ssid[] = "<WLAN-SSID>";
const char pass[] = "<WLAN-PASSWORD>";
const char domain[] = "vrpc-arduino";
const char token[] = "";
const char host[] = "vrpc.io";

SSD1311 Screen;
WiFiClient wifi;
VrpcAgent agent;

void setText(String text, int row = 0) {
  clearRow(row);
  Screen.sendString(text.c_str(), row * 32, 0);
}

String getText() {
  String result;
  char buffer[] = "                    0";
  Screen.readString(buffer, 0, 0, 20);
  result += String(buffer) + "\n";
  Screen.readString(buffer, 32, 0, 20);
  result += String(buffer) + "\n";
  Screen.readString(buffer, 64, 0, 20);
  result += String(buffer) + "\n";
  Screen.readString(buffer, 96, 0, 20);
  result += String(buffer) + "\n";
  return result;
}

void clearRow(int row) {
  Screen.sendString("                    ", row * 32, 0);
}

void connect() {
  while (WiFi.status() != WL_CONNECTED) {
    Screen.sendString("Connect WiFi...     ", 0, 0);
    WiFi.begin(ssid, pass);
    delay(1000);
  }
  Screen.sendString("Connect WiFi... OK", 0, 0);
  agent.connect();
}

void setup() {
  Wire.begin();
  pinMode(6, OUTPUT);
  digitalWrite(6, HIGH);
  Screen.powerMode(SSD1311_LCD_ON);
  Screen.clear();

  WiFi.begin(ssid, pass);
  agent.begin(wifi, domain, token, host);

  connect();
}

void loop() {
  agent.loop();
  if (!agent.connected()) {
    connect();
  }
}

VRPC_GLOBAL_FUNCTION(void, setText, String, int);
VRPC_GLOBAL_FUNCTION(String, getText);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.heisenware.com/developers/vrpc/languages/arduino/examples/oled-display-agent.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
